static Handle:hFirstSymbolTrie	= INVALID_HANDLE;
static Handle:hPhraseTrie		= INVALID_HANDLE;

stock wS_ReloadExceptions()
{
	if (hFirstSymbolTrie)
	{
		CloseHandle(hFirstSymbolTrie);
		hFirstSymbolTrie		= INVALID_HANDLE;
	}

	if (hPhraseTrie)
	{
		CloseHandle(hPhraseTrie);
		hPhraseTrie				= INVALID_HANDLE;
	}

	new Handle:kv				= CreateKeyValues("exceptions");
	if (FileToKeyValues(kv,		"cfg/vip/modules/chat/exceptions.txt") && KvGetNum(kv, "enabled") == 1)
	{
		wS_Lemur(kv,			"FIRST_SYMBOL",			hFirstSymbolTrie);
		wS_Lemur(kv,			"PHRASE",				hPhraseTrie);
	}
	CloseHandle(kv);
}

static wS_Lemur(Handle:kv, const String:sKey[], &Handle:hTrie)
{
	KvRewind(kv);
	if (KvJumpToKey(kv, sKey, false) && KvGotoFirstSubKey(kv, false))
	{
		decl String:info[512];
		do
		{
			KvGetString(kv,	"", info, sizeof(info));
			if (TrimString(info))
			{
				if (!hTrie) hTrie = CreateTrie();
				SetTrieValue(hTrie, info, 1);
				//PrintToServer(info);
			}
		}
		while (KvGotoNextKey(kv, false));
	}
}

stock bool:wS_ExceptionSymbol(const String:sKey[], x = -1) return hFirstSymbolTrie && GetTrieValue(hFirstSymbolTrie, sKey, x);
stock bool:wS_ExceptionPhrase(const String:sKey[], x = -1) return hPhraseTrie && GetTrieValue(hPhraseTrie, sKey, x);